import { Service } from "entity";
import { SelectQueryBuilder } from "typeorm";
import CommonHelper from "../helpers/common";
import { OrmHelper } from "../helpers/orm";

export class ServiceModel {
	static async list(filterObj = {}, filterAny: string = ""): Promise<SelectQueryBuilder<any>> {
		const repo = OrmHelper.DB.getRepository(Service);
		let whereAttr: string[] = [];
		let whereVal: any = {};
		if (filterObj && Object.keys(filterObj).length > 0) {
			const filterResult = CommonHelper.handleQueryFilter(filterObj, "Service");
			whereAttr = [...whereAttr, ...filterResult.whereAttr];
			whereVal = { ...whereVal, ...filterResult.whereVal };
		}

		if (filterAny && filterAny !== "" && filterAny !== null && filterAny !== undefined) {
			const filterResult = CommonHelper.handleFilter({
				filter: JSON.stringify({ any: filterAny }),
				col_any_eq: [],
				col_any_like: ["Service.name"],
			});

			if (filterResult.whereAttr && filterResult.whereAttr !== "") {
				whereAttr = [...whereAttr, filterResult.whereAttr];
				whereVal = { ...whereVal, ...filterResult.whereVal };
			}
		}

		var query = repo
			.createQueryBuilder("Service")

		if (whereAttr.length != 0) {
			query = query.where(whereAttr.join(" and "), whereVal);
		}

		return query;
	}
}
